;**************************************************************
;***    XMS0D.ASM                                           ***
;***                                                        ***
;***    function        XMS_XmBlk.unlockXM                  ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Unlocks a previously locked memory block.           ***
;***                                                        ***
;**************************************************************

        .model  large,pascal 

        include xmsdefs.asm 

        extrn   errno:WORD  
        extrn   xmsHandler:DWord

;
;   Define entry point
;
        public  XMS_XmBlk@unlockXM

        .code

XMS_XmBlk@unlockXM  proc    handle:Far Ptr Word

        les     bx,handle
        mov     dx,es:[bx]          ; handle of block to lock
        mov     ah,XMSUnlockXM      ; Function code
        call    xmsHandler          ; call the guy

        or      ax,ax               ; AX=0 means error
        jz      errorReturn

        mov     ax,XMSErrOK         ; No error
        ret

errorReturn:
        mov     al,bl               ; Move error code to AL
        xor     ah,ah               ; Zero extend to 16 bits
        mov     errno,ax            ; Copy to errno
        ret

XMS_XmBlk@unlockXM  endp            ; end of procedure

        end
